COMMENT %
   TABSIZE = 2 !

   Quickbasic 4.5 simple mode 13h library.
   Written by - Sten Daniel Srsdal.

   Version 4.0

   Note: even though this was originally written for QB4.5
         I have taken alot of extra time to optimize it for PB3.2.
         since PowerBAsiC gives me (the programmer) alot of powerful
         tools to play with, i have used them to the fullest.
         One of them are less push/pops !

   Note: I have converted this back from PB3.5 (after some updates)
         Its not optimized for QB at all. If you want faster executables
         and routines i strongly urge you to move on to PowerBasic.
         Its much more powerful and is very compatible with older QB
         source. Its even more powerful that QB 7.1.
         -> Also note that this isnt the fastest routines in the world
            Im not trying to pass this off as revolutionary, but i guarantee
            its faster than most. Since most libraries out there uses 8086
            code and the coders are pretty new.
         -> There will be some bugs, im sure. I havent had time to test it
            out thoroughly and some bugs reports on both the line routine
            and the Get routines have been reported. Since i dont have time
            to find them now, you could send me a note on how to fix it.
            Only the Put routine supports clipping, the others will try to
            put where ever you specify which will often leed to crashes.
            Use with care!
         -> I can do routines on request, if you want anything added to this
            library i will be glad to include it. But do send me some example
            source in either q/pbasic or asm.

  Contact me with questions, requests or notes.
  e-mail : prinz@c2i.net
  irc    : efnet #quickbasic

%         

.model medium, basic
.386
.code

even
XPut13h  proc public uses bx cx es si di ds SSegm:word, SOffs:word, Xpos:word, Ypos:word
;
; 16x16 optimized put routine.
;

        ; initialize
        mov bx, SSource         ; Why dont i just e.g. 'mov ds, SSegm' ?
        mov ax, SSegm           ; Because moving from memory to segmentreg.
        mov si, SOffs           ; takes _9_ cycles, moving via a register
        mov es, bx              ; like ax takes 1+3 = 4 cycles
        mov ds, ax              ; There, i saved 5 cycles !

                                ; If i calculate here, i save alot of cycles
                                ; but please note, this is as fast as
                                ; i could calculate Y*320+X anyways.
        mov ax, Ypos            ; ax <= Ypos
        mov di, ax              ; di <= Ypos
        mov bx, Xpos            ; bx <= bx
        shl ax, 8               ; ax * 256
        shl di, 6               ; di * 64
        add di, ax              ; ax(*256) + di(*64) = di(*320)
        add di, bx              ; di + Xpos
       
        add si, 4               ; skip header

        mov dx, 16
        cld
ForYLOOP1:
        mov cx, 4
        rep movsd
        add di, 320-16
        dec dx
        jnz ForYLoop1

Quit:
        ret                     ; return to basic
XPut13h endp


even
GetPalette13h proc public uses bx cx es di segm:word, offs:word
; 3C7h
; 3C9h
  mov ax, segm
  mov di, offs
  mov es, ax
  mov cx, 0
@@:
  mov dx, 3C7h
  mov al, cl
  out dx, al
  mov dx, 3C9h
  inc di
  insb
  insb
  insb
  inc cx
  cmp cx, 256
  jnz @B
  ret
GetPalette13h endp

even
PutPalette13h proc public uses cx  ds si segm:word, offs:word
  mov ax, segm
  mov si, offs
  mov ds, ax
  mov cx, 0
@@:
  mov dx, 3C8h
  mov al, cl
  out dx, al
  mov dx, 3C9h
  inc di
  outsb
  outsb
  outsb
  inc cx
  cmp cx, 256
  jnz short @B
  ret
PutPalette13h endp

even
ModPalette13h proc public Red:word, Green:word, blue:word, Col:word
  mov dx, 3C8h
  mov ax, Col
  out dx, al
  mov dx, 3C9h
  mov ax, Red
  out dx, al
  mov ax, Green
  out dx, al
  mov ax, blue
  out dx, al
  ret
ModPalette13h endp

even
Put13h  proc public uses bx cx es si di ds SSegm:word, SOffs:word, Xpos:word, Ypos:word, Color:word

        
        ; initialize
        mov bx, SSource         ; Why dont i just e.g. 'mov ds, SSegm' ?
        mov ax, SSegm           ; Because moving from memory to segmentreg.
        mov si, SOffs           ; takes _9_ cycles, moving via a register
        mov es, bx              ; like ax takes 1+3 = 4 cycles
        mov ds, ax              ; There, i saved 5 cycles !

                                ; If i calculate here, i save alot of cycles
                                ; but please note, this is as fast as
                                ; i could calculate Y*320+X anyways.
        mov ax, Ypos            ; ax <= Ypos
        mov di, ax              ; di <= Ypos
        mov bx, Xpos            ; bx < = bx
        shl ax, 8               ; ax * 256
        shl di, 6               ; di * 64
        add di, ax              ; ax(*256) + di(*64) = di(*320)
        add di, bx              ; di + Xpos
        mov AOffset2, di        ; Store it for later use.
        
        ; Width
        lodsw                   ; Get width
        shr ax, 3               ; divide by 8
        jz Quit                 ; if its zero, quit
        mov PWidth2, ax         ; store width
        mov bx, ax              ; store width temporarely
        add bx, Xpos            ; add xpos
        
        
        ; Height
        lodsw                   ; Get height
        or ax, ax               ; check if its zero
        jz Quit                 ; Quit if it is (illigal value)
        add ax, Ypos            ; add Ypos to it.
        mov PHY2, ax            ; Store it in P(ut)H(eight)Y(pos)2
        
        cmp bx, 319             ; check if its within boundaries
        ja ForYLOOP3            ; Jump to boundary handling put if its not.
        cmp ax, 199             ; --||--
        ja ForYLOOP3            ; --||--
        cmp Ypos, 0             ; --||--
        jl ForYLOOP3            ; --||--
        cmp Xpos, 0             ; --||--
        jl ForYLOOP3            ; --||--
        
Fast1:                          ; *** This PUT routine checks ***
                                ; *** For color only          ***

                                ; These 4 lines done just once.
        mov dx, 320             ; mov Max-Width (For later calc)
        sub dx, PWidth2         ; subtract the width.
        mov bx, PHY2            ; mov bx, PHY2 (used as counter)
        sub bx, Ypos            ; subtract height
        mov ax, Color           ; value to check for
        xchg ah, al             ; * added *
even
ForYLOOP2:
            mov cx, PWidth2     ; How many X pixels will i plot.
even
ForXLOOP2:
;            lodsb               ; Load the color.
            mov al, ds:[si]
            cmp al, ah          ; If its Zero,
            jz @F               ; then dont plot.
            mov es:[di], al     ; Store the color.
            @@:                 
            inc di              ; inc destination index
            inc si              ; inc source index
            dec cx
            jnz ForXLOOP2       ; LOOP for a new pixel

          add di, dx            ; move di to the next line.
                                ; instead of recalcing Y*320+X
          dec bx                ; decrease counter until zero
          jnz ForYLOOP2         ; If its not zero, go again.
          jmp short Quit        ; Quit.

even
ForYLOOP3:                      ; *** This PUT routine checks for ***
                                ; *** Boundaries as well as color ***
        mov ax, 320             ; move max width
        sub ax, PWidth2         ; subtract object width
        mov dx, Ypos            ; move Ypos into dx.
        mov AOffset2, ax        ; Store it for later calculation.
                                ; This line was moved down one because of
                                ; AGI stall.
        mov ax, Color
        xchg al, ah
ForYLOOP1:
        mov cx, PWidth2         ; Get number of X pixels we might plot.
        mov bx, Xpos            ; Get Xpos.

        cmp dx, 199             ; Compare dx (dx is current Ypos counter),
                                ; dx is loaded earlier on.
        jg Quit                 ; If its not greater then do another line.
        cmp dx, 0               ; Compare dx with Zero
        Jnl ForXLOOP1           ; If its not less than 0 (eg. negative)
                                ; Then we do another line
                                ; This line is out of the screen -
        add di, 320             ; Skip a line
        add si, PWidth2         ; Update the object pointer.
        jmp short Skipaline     ; Jump further
ForXLOOP1:
            lodsb               ; Load the color.
            cmp al, ah          ; compare al
            jz EofX1            ; Then dont plot
            cmp bx, 319         ; Compare bx, with 319
            ja EofX1            ; IF -x or x > 320 THEN GOTO dontplot
                                ; Apparently this pixel is within bounds.
            mov es:[di], al     ; Store the color.
            EofX1:
            inc bx              ; increase bx (Xpos counter)
            inc di              ; increase on screen pointer
            dec cx
            jnz ForXLOOP1      ; LOOP for the next pixel
          
          add di, AOffset2      ; add the precalulated width.
                                ; This is faster then recalculating
                                ; the Y*320*X again.

Skipaline:                      ; If the object line was out of Y bounds
                                ; then we go here. (Saving alot of cycles)
          inc dx                ; increase Ypos counter
          cmp dx, PHY2          ; If Ypos <> PHY2 then
          jnz ForYLOOP1         ; Then we have more data to move.

Quit:
        ret                     ; return to basic
even
  PWidth2  word  ?
  PHY2     word  ?
  AOffset2 word  ?
Put13h endp



even
Line13h proc public uses bx cx es di LX1:word, LY1:word, LX2:word, LY2:word, Colr:word

        mov dx, SSource
        mov XStep, 1
        mov es, dx
        mov YStep, 320

        mov ax, LX2
        sub ax, LX1
        mov Xdiff, ax

        mov ax, LY2
        sub ax, LY1
        mov Ydiff, ax

        mov dx, Colr

CompX:  mov ax, LX1
        mov bx, LX2
        cmp ax, bx
        jle CompY
        neg XStep
        neg Xdiff

CompY:  mov ax, LY1
        mov bx, LY2
        cmp ax, bx
        jle BegPlt
        neg YStep
        neg Ydiff

BegPlt: mov ax, LY1
        mov di, ax
        shl di, 6
        shl ax, 8
        add di, LX1
        add di, ax

LType:  mov ax, Xdiff
        cmp ax, Ydiff
        jle DoY

DoX:    xor bx, bx
        mov cx, ax
        inc cx
        or ax, ax
        jg LOOPX1
        neg cx
        
LoopX1: mov dx, Colr
        xor ax, ax

LoopX:  mov es:[di], DL
        add di, XStep
        add ax, Ydiff
        cmp ax, Xdiff
        jl NextX
        add di, YStep
        sub ax, Xdiff

NextX:  dec cx
        jnz LoopX
        jmp Exit

DoY:    mov cx, bx
        inc cx
        or bx, bx
        jg LOOPY
        mov ax, bx
        neg cx
        xor ax, ax
        
LOOPY:  mov es:[di], DL
        add di, YStep
        add ax, Xdiff
        cmp ax, Ydiff
        jl NextY
        add di, XStep
        sub ax, Ydiff

NextY:  dec cx
        jnz LOOPY

Exit:   ret


even
Xdiff word  ?
Ydiff word  ?
XStep word  ?
YStep word  ?
Line13h endp

even
FPut13h  proc public uses bx cx es si di ds SSegm:word, SOffs:word, Xpos:word, Ypos:word

      
        ; initialize
        mov bx, SSource         ; Why dont i just e.g. 'mov ds, SSegm' ?
        mov ax, SSegm           ; Because moving from memory to segmentreg.
        mov si, SOffs           ; takes _9_ cycles, moving via a register
        mov es, bx              ; like ax takes 1+3 = 4 cycles
        mov ds, ax              ; There, i saved 5 cycles !

        mov ax, Ypos            ; ax <= Ypos
        mov di, ax              ; di <= Ypos
        mov bx, Xpos            ; bx < = bx
        shl ax, 8               ; ax * 256
        shl di, 6               ; di * 64
        add di, ax              ; ax(*256) + di(*64) = di(*320)
        add di, bx              ; di + Xpos
        mov AOffset, di
        
        ; Width
        lodsw                   ; Get width
        shr ax, 3               ; divide by 8
        jz Quit                 ; if its zero, quit
        mov PWidth, ax          ; store width
        mov bx, ax              ; store width temporarely
        add bx, Xpos            ; add xpos
        
        
        ; Height
        lodsw                   ; Get height.
        or ax, ax               ; If its zero,
        jz Quit                 ; then quit.
        add ax, Ypos            ; Height+Ypos
        mov PHY, ax             ; Save it for later. P(ut)H(eight)Y(pos)

          cmp bx, 319           ; check if its within bounds,
          ja ForYLOOP4          ; If not then goto boundary handling put.
          cmp ax, 199           ; --||--
          ja ForYLOOP4          ; --||--
          cmp Ypos, 0           ; --||--
          jl ForYLOOP4          ; --||--
          cmp Xpos, 0           ; --||--
          jl ForYLOOP4          ; --||--

Fast2:                          ; *** This PUT routine checks for ***
                                ; *** NOTHinG - FAST!!!           ***

          mov dx, PWidth        ; Get width.      (Used in LOOP)
          mov ax, 320           ; Get max width,
          sub ax, dx            ; subtract width.
          mov bx, PHY           ; Get (Height+Ypos)
          sub bx, Ypos          ; (Height+Ypos)-Ypos
          
          cld                   ; clear direction flag.
even
@@:
          mov cx, dx            ; Put Width into cx
          shr cx, 1             ; cx = cx \ 2
          rep movsw             ; Copy words
          adc cx, cx            ; If there one left
          rep movsb             ; Copy the last byte (if any)
          add di, ax            ; update on screen pointer.
          dec bx                ; bx = bx - 1
          jnz @B                ; If bx is Zero then go for another line.
          jmp short Quit        ; Else quit.


ForYLOOP4:                      ; *** This PUT routine checks for ***
                                ; *** Boundaries. ***

          mov ax, 320           ; Get Max width
          sub ax, PWidth        ; subtract object width
          mov AOffset, ax       ; Store it for later use
          mov dx, Ypos          ; Get dx, Ypos
even
ForYLOOP3:
          mov cx, PWidth
          mov bx, Xpos
even
          cmp dx, 199
          jng @F
          jmp short Quit
@@:
          cmp dx, 0
          Jnl ForXLOOP3
          add di, 320
          add si, cx
          jmp short Skipaline
ForXLOOP3:
            mov al, ds:[si]
            cmp bx, 319
            ja @F               ; IF -x or x > 320 THEN GOTO dontplot
            mov es:[di], al     ; Store the color
            @@:
            inc bx
            inc di
            inc si
            dec cx
            jnz ForXLOOP3
          
          add di, AOffset
Skipaline:
          inc dx
          cmp dx, PHY
          jne ForYLOOP3

Quit:
        ret                     ; return to basic
even
  PWidth  word  ?
  PHY     word  ?
  AOffset word  ?
FPut13h  endp

even
replace13h proc public uses bx cx es di OldCol:word, NewCol:word
  mov ax, SSource
  mov cx, 64000
  xor di, di
  mov es, ax
  mov ax, OldCol
  mov bx, NewCol
  cld
repLOOP:
  repnz scasb
  jcxz repNoMore
  mov es:[di-1], bl
  jmp short repLOOP
repNoMore:
  ret
replace13h endp

even
WaitVbl proc public
  mov dx, 3DAH
@@:
  in al, dx
  and al, 8
  jz @B
  ret
WaitVbl endp

even
SetSegments13h proc public SSegm:word, dsegm:word
  mov ax, SSegm
  mov dx, dsegm
  mov SSource, ax
  mov dsource, dx
  ret
SetSegments13h endp

even
Copy13h proc public uses bx cx es di si ds
        cld
        mov cx, 16000
        mov ax, SSource         ; Funny enough, PB doesnt require OFfsETS
        mov bx, dsource         ; into arrays.
        xor si, si
        mov ds, ax              ; PB is efficient enough to alIGN its array
        mov es, bx              ; in a PARAGRAPH (16 bytes) - nice !
        xor di, di              ; (Note: My QB version is "aligning" the offsets)
        even                    ; align it even (just in case)
        rep movsd               ; 32bit copy of data (Dword copy) *fast*.
        ret                     ; return to whomever called us.
Copy13h endp

even
cls13h proc public uses bx cx es di Col:word
        mov bx, SSource
        mov ax, Col
        mov es, bx
        mov AH, al
        xor di, di
        shl Eax, 16
        mov ax, Col
        mov AH, al
        mov cx, 16000
        rep stosd               ; move double words (Eax) for super-fast-speed
        ret
cls13h endp

even
Get13h  proc public uses bx cx es si di ds dsegm:word, DOffs:word, X1:word, Y1:word, X2:word, Y2:word
        ; init.
        mov bx, dsegm           ; mov Destination segment temp. into bx
        mov ax, SSource         ; ditto for Source segment
        mov di, DOffs
        mov es, bx              ; mov dsegm -> bx -> es
        mov ds, ax              ; mov SSegm -> ax -> ds
        
        cmp X2, 320
        Jna @F
          mov X2,320
        @@:
        cmp Y2, 200
        Jna @F
          mov Y2, 200
        @@:

        mov ax, X2
        sub ax, X1
        inc ax
        mov GWidth, ax
        shl ax, 3
        stosw
        
        mov ax, Y2
        sub ax, Y1
        inc ax
        stosw
        inc Y2
        
ForYLOOPG:
          mov bx, X1
          mov ax, Y1
          mov si, ax
          shl ax, 8                 ; Faster than : mov AH, al ; xor al, al ?
          shl si, 6
          add si, ax
          add si, bx
          
          mov cx, GWidth
          mov dx, Y1
ForXLOOPG:
          rep movsb
NoXLOOPG:
          mov ax, Y2
          inc Y1
          cmp ax, Y1
          jne ForYLOOPG
        
        ret
; different variables
even
GWidth    word  ?
GHeight   word  ?
Get13h  endp

even
PSet13h proc public uses bx cx Xpos:word, Ypos:word, Col:word
        
        mov dx, SSource
        mov ax, Ypos
        mov es, dx
        mov bx, ax
        
        shl ax, 8
        shl bx, 6

        add bx, ax
        add bx, Xpos
        mov ax, Col
        mov es:[bx], al

        ret
PSet13h endp

even
Point13h proc public uses bx cx Xpos:word, Ypos:word
        
        mov ax, Ypos
        mov dx, SSource
        mov bx, ax
        mov es, dx
        
        shl ax, 8
        shl bx, 6

        add bx, ax
        add bx, Xpos
        xor ax, ax
        mov al, es:[bx]
       
        ret
Point13h endp

even
SSource word  ?
dsource word  ?
END
